package cn.com.infosec.asn1.cmp;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1EncodableVector;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.ASN1TaggedObject;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DERSequence;
import cn.com.infosec.asn1.DERTaggedObject;

public class CertRepMessage extends ASN1Encodable {
   private ASN1Sequence caPubs;
   private ASN1Sequence response;

   private CertRepMessage(ASN1Sequence seq) {
      byte var2 = 0;
      if (seq.size() > 1) {
         byte var10002 = var2;
         var2 = 1;
         this.caPubs = ASN1Sequence.getInstance((ASN1TaggedObject)seq.getObjectAt(var10002), true);
      }

      this.response = ASN1Sequence.getInstance(seq.getObjectAt(var2));
   }

   public static CertRepMessage getInstance(Object o) {
      if (o instanceof CertRepMessage) {
         return (CertRepMessage)o;
      } else if (o instanceof ASN1Sequence) {
         return new CertRepMessage((ASN1Sequence)o);
      } else {
         throw new IllegalArgumentException("Invalid object: " + o.getClass().getName());
      }
   }

   public CMPCertificate[] getCaPubs() {
      ASN1Sequence var1;
      if ((var1 = this.caPubs) == null) {
         return null;
      } else {
         int var4;
         CMPCertificate[] var2 = new CMPCertificate[var4 = var1.size()];

         for(int var3 = 0; var3 != var4; ++var3) {
            var2[var3] = CMPCertificate.getInstance(this.caPubs.getObjectAt(var3));
         }

         return var2;
      }
   }

   public CertResponse[] getResponse() {
      int var1;
      CertResponse[] var2 = new CertResponse[var1 = this.caPubs.size()];

      for(int var3 = 0; var3 != var1; ++var3) {
         var2[var3] = CertResponse.getInstance(this.caPubs.getObjectAt(var3));
      }

      return var2;
   }

   public DERObject toASN1Object() {
      ASN1EncodableVector var1;
      var1 = new ASN1EncodableVector.<init>();
      ASN1Sequence var2;
      if ((var2 = this.caPubs) != null) {
         DERTaggedObject var3;
         var3 = new DERTaggedObject.<init>(true, 1, var2);
         var1.add(var3);
      }

      var1.add(this.response);
      return new DERSequence(var1);
   }
}
